﻿using System;
using System.Runtime.InteropServices;
using System.ComponentModel;
using System.Windows.Forms;
using AddinExpress.MSO;

namespace CalculationModeChanged
{
    /// <summary>
    ///   Add-in Express Add-in Module
    /// </summary>
    [GuidAttribute("CAA431D3-1D3D-42B0-8855-C7702924F6B7"), ProgId("CalculationModeChanged.AddinModule")]
    public class AddinModule : AddinExpress.MSO.ADXAddinModule
    {
        public AddinModule()
        {
            Application.EnableVisualStyles();
            InitializeComponent();
            // Please add any initialization code to the AddinInitialize event handler
        }

        private ADXRibbonCommand adxRibbonCommandAutomatic;
        private ADXRibbonCommand adxRibbonCommandExceptTables;
        private ADXRibbonCommand adxRibbonCommandManual;
        private ADXRibbonCommand adxRibbonCommandOptionsDialog;
        private ADXBuiltInControl adxBuiltInControlToolsOptions;
        private ADXExcelAppEvents adxExcelEvents;
 
        #region Component Designer generated code
        /// <summary>
        /// Required by designer
        /// </summary>
        private System.ComponentModel.IContainer components;
 
        /// <summary>
        /// Required by designer support - do not modify
        /// the following method
        /// </summary>
        private void InitializeComponent()
        {
            this.components = new System.ComponentModel.Container();
            this.adxRibbonCommandAutomatic = new AddinExpress.MSO.ADXRibbonCommand(this.components);
            this.adxRibbonCommandExceptTables = new AddinExpress.MSO.ADXRibbonCommand(this.components);
            this.adxRibbonCommandManual = new AddinExpress.MSO.ADXRibbonCommand(this.components);
            this.adxRibbonCommandOptionsDialog = new AddinExpress.MSO.ADXRibbonCommand(this.components);
            this.adxBuiltInControlToolsOptions = new AddinExpress.MSO.ADXBuiltInControl(this.components);
            this.adxExcelEvents = new AddinExpress.MSO.ADXExcelAppEvents(this.components);
            // 
            // adxRibbonCommandAutomatic
            // 
            this.adxRibbonCommandAutomatic.ActionTarget = AddinExpress.MSO.ADXRibbonCommandTarget.ToggleButton;
            this.adxRibbonCommandAutomatic.Id = "adxRibbonCommand_8a31e6e55f78463ca53c14d2c68a85c8";
            this.adxRibbonCommandAutomatic.IdMso = "CalculationOptionsAutomatically";
            this.adxRibbonCommandAutomatic.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.adxRibbonCommandAutomatic.OnAction += new AddinExpress.MSO.ADXRibbonCommand_EventHandler(this.adxRibbonCommandAutomatic_OnAction);
            // 
            // adxRibbonCommandExceptTables
            // 
            this.adxRibbonCommandExceptTables.ActionTarget = AddinExpress.MSO.ADXRibbonCommandTarget.ToggleButton;
            this.adxRibbonCommandExceptTables.Id = "adxRibbonCommand_f4826f22406447fca13f95ffc1f43d64";
            this.adxRibbonCommandExceptTables.IdMso = "CalculationOptionsAutomaticallyExceptDataTables";
            this.adxRibbonCommandExceptTables.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.adxRibbonCommandExceptTables.OnAction += new AddinExpress.MSO.ADXRibbonCommand_EventHandler(this.adxRibbonCommandExceptTables_OnAction);
            // 
            // adxRibbonCommandManual
            // 
            this.adxRibbonCommandManual.ActionTarget = AddinExpress.MSO.ADXRibbonCommandTarget.ToggleButton;
            this.adxRibbonCommandManual.Id = "adxRibbonCommand_7ffc4e34ef2c4ad2b4cf135bad083ea5";
            this.adxRibbonCommandManual.IdMso = "CalculationOptionsManuallly";
            this.adxRibbonCommandManual.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.adxRibbonCommandManual.OnAction += new AddinExpress.MSO.ADXRibbonCommand_EventHandler(this.adxRibbonCommandManual_OnAction);
            // 
            // adxRibbonCommandOptionsDialog
            // 
            this.adxRibbonCommandOptionsDialog.Id = "adxRibbonCommand_9bb217d6861f4ecc913107f51981cd85";
            this.adxRibbonCommandOptionsDialog.IdMso = "ApplicationOptionsDialog";
            this.adxRibbonCommandOptionsDialog.Ribbons = AddinExpress.MSO.ADXRibbons.msrExcelWorkbook;
            this.adxRibbonCommandOptionsDialog.OnAction += new AddinExpress.MSO.ADXRibbonCommand_EventHandler(this.adxRibbonCommandOptionsDialog_OnAction);
            // 
            // adxBuiltInControlToolsOptions
            // 
            this.adxBuiltInControlToolsOptions.CommandBar = null;
            this.adxBuiltInControlToolsOptions.ControlTag = "8050f3cb-988e-4a8c-8e85-03d7ce2019e1";
            this.adxBuiltInControlToolsOptions.Id = 522;
            this.adxBuiltInControlToolsOptions.ActionEx += new AddinExpress.MSO.ADXActionEx_EventHandler(this.adxBuiltInControlToolsOptions_ActionEx);
            // 
            // adxExcelEvents
            // 
            this.adxExcelEvents.WorkbookOpen += new AddinExpress.MSO.ADXHostActiveObject_EventHandler(this.adxExcelEvents_WorkbookOpen);
            // 
            // AddinModule
            // 
            this.AddinName = "CalculationModeChanged";
            this.SupportedApps = AddinExpress.MSO.ADXOfficeHostApp.ohaExcel;
            this.AddinInitialize += new AddinExpress.MSO.ADXEvents_EventHandler(this.AddinModule_AddinInitialize);
            this.OnSendMessage += new AddinExpress.MSO.ADXSendMessage_EventHandler(this.AddinModule_OnSendMessage);

        }
        #endregion
 
        #region Add-in Express automatic code
 
        // Required by Add-in Express - do not modify
        // the methods within this region
 
        public override System.ComponentModel.IContainer GetContainer()
        {
            if (components == null)
                components = new System.ComponentModel.Container();
            return components;
        }
 
        [ComRegisterFunctionAttribute]
        public static void AddinRegister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXRegister(t);
        }
 
        [ComUnregisterFunctionAttribute]
        public static void AddinUnregister(Type t)
        {
            AddinExpress.MSO.ADXAddinModule.ADXUnregister(t);
        }
 
        public override void UninstallControls()
        {
            base.UninstallControls();
        }

        #endregion

        public static new AddinModule CurrentInstance 
        {
            get
            {
                return AddinExpress.MSO.ADXAddinModule.CurrentInstance as AddinModule;
            }
        }

        public Excel._Application ExcelApp
        {
            get
            {
                return (HostApplication as Excel._Application);
            }
        }

        private const int WM_USER = 0x0400;
        private bool cancelAction = true;


        // Ribbon button
        private int WM_OptionAutomatic = WM_USER + 2001;
        private void adxRibbonCommandAutomatic_OnAction(object sender, IRibbonControl control, bool pressed, ADXCancelEventArgs e)
        {
            e.Cancel = cancelAction;
            System.Diagnostics.Debug.Print("adxRibbonCommandAutomatic_OnAction. cancelAction=" + cancelAction.ToString());
            if (cancelAction)
            {
                this.SendMessage(WM_OptionAutomatic); //see AddinModule_OnSendMessage
            }
        }

        // Ribbon button
        private int WM_OptionSemiAutomatic = WM_USER + 2002;
        private void adxRibbonCommandExceptTables_OnAction(object sender, IRibbonControl control, bool pressed, ADXCancelEventArgs e)
        {
            e.Cancel = cancelAction;
            System.Diagnostics.Debug.Print("adxRibbonCommandExceptTables_OnAction. cancelAction=" + cancelAction.ToString());
            if (cancelAction)
            {
                this.SendMessage(WM_OptionSemiAutomatic); //see AddinModule_OnSendMessage
            }
        }

        // Ribbon button
        private int WM_OptionManual = WM_USER + 2003;
        private void adxRibbonCommandManual_OnAction(object sender, IRibbonControl control, bool pressed, ADXCancelEventArgs e)
        {
            e.Cancel = cancelAction;
            System.Diagnostics.Debug.Print("adxRibbonCommandManual_OnAction. cancelAction=" + cancelAction.ToString());
            if (cancelAction)
            {
                this.SendMessage(WM_OptionManual); //see AddinModule_OnSendMessage
            }
        }

        // Options dialog (Ribbon)
        private int WM_RibbonOptions = WM_USER + 2004;
        private void adxRibbonCommandOptionsDialog_OnAction(object sender, IRibbonControl control, bool pressed, ADXCancelEventArgs e)
        {
            e.Cancel = cancelAction;
            System.Diagnostics.Debug.Print("ApplicationOptionsDialog cancelAction=" + cancelAction.ToString());
            if (cancelAction)
            {
                this.SendMessage(WM_RibbonOptions); //see AddinModule_OnSendMessage
            }
        }

        // Options dialog (CommandBar)
        private int WM_CommandbarOptions = WM_USER + 2005;
        private void adxBuiltInControlToolsOptions_ActionEx(object sender, ADXCancelEventArgs e)
        {
            e.Cancel = cancelAction;
            System.Diagnostics.Debug.Print("Tools|Options cancelAction=" + cancelAction.ToString());
            if (cancelAction)
            {
                this.SendMessage(WM_CommandbarOptions); //see AddinModule_OnSendMessage
            }
        }

        private void AddinModule_OnSendMessage(object sender, ADXSendMessageEventArgs e)
        {
            if (e.Message == WM_OptionAutomatic)
            {
                System.Diagnostics.Debug.Print("AddinModule_OnSendMessage. WM_OptionAutomatic");
                cancelAction = false;
                this.CommandBarsObj.GetType().InvokeMember("ExecuteMso", 
                    System.Reflection.BindingFlags.InvokeMethod, 
                    null, this.CommandBarsObj, 
                    new object[] { "CalculationOptionsAutomatically" });
                CheckCalculationMode();
                cancelAction = true;
            }
            else if (e.Message == WM_OptionSemiAutomatic)
            {
                System.Diagnostics.Debug.Print("AddinModule_OnSendMessage. WM_OptionSemiAutomatic");
                cancelAction = false;
                this.CommandBarsObj.GetType().InvokeMember("ExecuteMso",
                    System.Reflection.BindingFlags.InvokeMethod,
                    null, this.CommandBarsObj,
                    new object[] { "CalculationOptionsAutomaticallyExceptDataTables" });
                CheckCalculationMode();
                cancelAction = true;
            }
            else if (e.Message == WM_OptionManual)
            {
                System.Diagnostics.Debug.Print("AddinModule_OnSendMessage. WM_OptionManual");
                cancelAction = false;
                this.CommandBarsObj.GetType().InvokeMember("ExecuteMso",
                    System.Reflection.BindingFlags.InvokeMethod,
                    null, this.CommandBarsObj,
                    new object[] { "CalculationOptionsManuallly" });
                CheckCalculationMode();
                cancelAction = true;
            }
            else if (e.Message == WM_RibbonOptions)
            {
                System.Diagnostics.Debug.Print("AddinModule_OnSendMessage. WM_RibbonOptions");
                cancelAction = false;
                this.CommandBarsObj.GetType().InvokeMember("ExecuteMso", System.Reflection.BindingFlags.InvokeMethod, null, this.CommandBarsObj, new object[] { "ApplicationOptionsDialog" });
                CheckCalculationMode();
                cancelAction = true;
            }
            else if (e.Message == WM_CommandbarOptions)
            {
                System.Diagnostics.Debug.Print("AddinModule_OnSendMessage. WM_CommandbarOptions");
                Office.CommandBars cmBars = this.CommandBarsObj as Office.CommandBars;
                Office.CommandBarButton btnToolsOptions = cmBars.FindControl(Office.MsoControlType.msoControlButton, 522, Type.Missing, Type.Missing) as Office.CommandBarButton;
                if (btnToolsOptions != null)
                {
                    cancelAction = false;
                    btnToolsOptions.Execute();
                    CheckCalculationMode();
                    cancelAction = true;
                    Marshal.ReleaseComObject(btnToolsOptions);
                }
            }
        }

        private object currentCalculationMode = null;
        private void CheckCalculationMode()
        {
            if (currentCalculationMode == null)
            {
                try
                {
                    currentCalculationMode = ExcelApp.Calculation;
                    if (ExcelApp.Calculation == Excel.XlCalculation.xlCalculationAutomatic)
                        currentCalculationMode = Excel.XlCalculation.xlCalculationManual;
                    else if (ExcelApp.Calculation == Excel.XlCalculation.xlCalculationManual)
                        currentCalculationMode = Excel.XlCalculation.xlCalculationAutomatic;
                    else
                        currentCalculationMode = Excel.XlCalculation.xlCalculationManual;
                }
                catch
                {
                    System.Diagnostics.Debug.Print("Something goes wrong");
                    return;
                }
            }
            if (ExcelApp.Calculation != (Excel.XlCalculation)currentCalculationMode)
            {
                currentCalculationMode = ExcelApp.Calculation;
                MessageBox.Show("Calculation mode has changed to " + currentCalculationMode.ToString());
            }
        }

        private void AddinModule_AddinInitialize(object sender, EventArgs e)
        {
            try
            {
                currentCalculationMode = ExcelApp.Calculation;
                System.Diagnostics.Debug.Print("AddinModule_AddinInitialize. currentCalculationMode=" + currentCalculationMode.ToString());
            }
            catch
            {
                // Excel 2013 and 2016: "Type mismatch" exception
            }
        }

        private void adxExcelEvents_WorkbookOpen(object sender, object hostObj)
        {
            currentCalculationMode = ExcelApp.Calculation;
            System.Diagnostics.Debug.Print("adxExcelEvents_WorkbookOpen. currentCalculationMode=" + currentCalculationMode.ToString());
        }
    }
}

